#ifndef _TIMER_H_
#define _TIMER_H_

/*
#
#    This distribution makes makes asynchronous client/server communication possible 
#    using TLVs (Type Length Value). It achieves that letting the user define
#    an IDL which serves as input to a code generator.  The code generated is linked in
#    the client and the server program.
#
#    Copyright (C) <2005>  <Sanjay Jaiman>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
*/

#include <sys/time.h>
#include <string.h>

class TimerElement {
 public:
  TimerElement(char *Name, unsigned int TOVal,  void (*callBack)(char *), bool recurring = true);
  ~TimerElement() {delete next; if (m_name) free(m_name); };
  
 public:
  bool   m_rucurring;
  char   *m_name;
  unsigned int timeVal;
  unsigned int timeoutVal;  /* does not change */
  void (*func)(char *);
  struct TimerElement *next;
  struct TimerElement *prev;
};

class Timer
{
 public:
  Timer(char *name = NULL) {if(name) strcpy(Name, name); else strcpy(Name, "default"); timerHead = NULL; timerTail = NULL; numtimers = 0; lastTime = NULL;};
  ~Timer() {};

  TimerElement *addTimer(char *name, unsigned int timeVal,  void (*callBack)(char *), bool recurring = true);
  int  getNewTimeToWait(struct timeval &t);
  void timerFired();
  int  deleteTimer(char *name);
  void printTimerList(char *id);
  TimerElement *getFirst() { return timerHead;};

 private:
  TimerElement *removeTimer(TimerElement *sb);
  void insertTimer(TimerElement *sb);
  unsigned int getTimeInMilliSecs(struct timeval tp);

 private:
  TimerElement *timerHead;
  TimerElement *timerTail;
  int numtimers;
  struct timeval *lastTime;
  char  Name[80];
};

#endif
